﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.Data;
using C1.Silverlight;

namespace MailMerging
{
    public partial class AddFields : UserControl
    {
        public string[] ReportFields { get; set; }

        public DataSet ReportSource { get; set; }
        public AddFields(string[] fields)
        {
            InitializeComponent();
            ReportFields = fields.Distinct().ToArray()  ;

            foreach (var field in fields.Distinct())
            {
               
                    var sp = new StackPanel() { Orientation = Orientation.Horizontal };
                    var label = new TextBlock() { Text = field,Width=200   };
                    sp.Children.Add(label);
                    sp.Children.Add(new TextBox() { Name = field, Width = 200});
                    Fields.Children.Add(sp);
                
            }
        }

        private void completed_Click(object sender, RoutedEventArgs e)
        {
            var dt = new DataTable();
            foreach (var field in ReportFields)
            {
                dt.Columns.Add(field,typeof(string));    
            }
           
            var dr = dt.NewRow();
           IList<DependencyObject>  list=new List<DependencyObject>();
           VTreeHelper.GetChildrenOfType(Fields, typeof(TextBox), ref list);

           foreach (var field in ReportFields)
           {
               var tb=list.First(t => ((TextBox)t).Name == field) as TextBox;  
               dr[field] = tb.Text; 
           }
         
               dt.Rows.Add(dr);
               var ds = new DataSet();
               ds.Tables.Add(dt);
               ReportSource = ds;
           
       

           (this.Parent as C1Window).Close(); 
        }
    }
}
