﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight;
using System.IO;

namespace MailMerging
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            // populate combo with report list
            var svc = new C1ReportServiceReference.C1ReportServiceClient();
            svc.GetReportListAsync();
            svc.GetReportListCompleted += (s, e) =>
                {
                    _cmbReports.ItemsSource = e.Result;
                };
        }

        private void _cmbReports_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // get report as PDF stream
            var svc = new C1ReportServiceReference.C1ReportServiceClient();

           svc.GetCalculatedFieldsAsync((string)_cmbReports.SelectedValue);
           svc.GetCalculatedFieldsCompleted += (s1, e1) =>
               {
                   var list =e1.Result.ToArray() ;
                   var window = new C1Window() { ShowCloseButton = false, ShowMaximizeButton = false, ShowMinimizeButton = false, IsResizable = false };
                   var af = new AddFields(list);
                   window.Content = af;
                   window.ShowModal();
                   window.CenterOnScreen();  
                   window.Closing += (s2, e2) =>
                       {

                           MemoryStream ms = new MemoryStream();
                           af.ReportSource.WriteXml(ms);
                          

                          svc = new C1ReportServiceReference.C1ReportServiceClient();
                          svc.GetReportWithCustomDataSourceAsync((string)_cmbReports.SelectedValue, ms.ToArray());
                          var mw = new C1Window() { Content = "Please Wait. Generating report....", ShowCloseButton = false, ShowMaximizeButton = false, ShowMinimizeButton = false, IsResizable = false };
                          mw.HorizontalContentAlignment = HorizontalAlignment.Center;
                          mw.VerticalContentAlignment = VerticalAlignment.Center;
                          mw.CenterOnScreen();
                          mw.ShowModal();
                          mw.HeaderBackground = new SolidColorBrush(Colors.Transparent);   
                           svc.GetReportWithCustomDataSourceCompleted+=(s3,e3)=>
                               {
                               ms = new System.IO.MemoryStream(e3.Result);
                              _c1rv.LoadDocument(ms);
                               mw.Close(); 
                               };
                       };
               };

 
        }

       

       
    }
}
